;; -*- hen -*-
(declare (unit LWS-headers)
		 (export <lws:headers>
				 initialize
				 clone
				 clear!
				 map-header
				 push-header!
				 get-value
				 remove-header!
				 set-header!
				 init-header!))

(use srfi-1
	 tinyclos)

(include "cleited-macros.scm")

(define-class <lws:headers> ()
  (alist))


(define-method (initialize (this <lws:headers>) args)
  (call-next-method)

  (initialize-slots this (list 'alist '())))


(define-method (clone (this <lws:headers>))
  (let [(new-obj (make <lws:headers>))]

	(map-header (lambda (key value)
				  (push-header! new-obj key value))
	    this)

	new-obj))


(define-method (clear! (this <lws:headers>))
  (slot-set! this 'alist '()))


(define-method (map-header (func <procedure>) (this <lws:headers>))
  (with-slots (alist) this

      (map (lambda (cell)
			 (func (car cell)
				   (cdr cell)))
		   alist)))


(define-method (push-header! (this <lws:headers>) (key <string>) (value <string>))
  (with-slots (alist) this

     (slot-set! this 'alist (cons (cons key value)
								  alist))))


(define-method (get-value (this <lws:headers>) (key <string>))
  ;; 最初に見付けた値を返す。無ければ #f を返す。
  (with-slots (alist) this
			  
	 (bind-exit exit
	     (for-each (lambda (cell)
					 (if (equal? (car cell) key)
						 (exit (cdr cell))))
				   alist)
		 #f)))


(define-method (remove-header! (this <lws:headers>) (key <string>))
  (with-slots (alist) this

      (slot-set! this 'alist
				 (filter (lambda (cell)
						   (not (equal? key (car cell))))
						 alist))))


(define-method (set-header! (this <lws:headers>) (key <string>) (value <string>))
  (remove-header! this key)
  (push-header!   this key value))


(define-method (init-header! (this <lws:headers>) (key <string>) (value <string>))
  (unless (get-value this key)
	(push-header! this key value)))