;; -*- hen -*-
(declare (unit LWS-request)
		 (uses LWS-headers
			   uri)
		 (export <lws:request>
				 initialize
				 clone
				 
				 lws:method-of
				 lws:uri-of
				 lws:headers-of
				 lws:content-of

				 lws:set-method!
				 lws:set-uri!
				 lws:set-headers!
				 lws:set-content!))

(use tinyclos)

(include "cleited-macros.scm")

(define-class <lws:request> ()
  (method
   uri
   headers
   content))

(define-accessors <lws:request>
  (method
   uri
   headers
   content)
  prefix: lws:)


(define-method (initialize (this <lws:request>) args)
  (call-next-method)

  (define (init method uri #!key (headers (make <lws:headers>)) (content ""))
	
	(assert (symbol?      method))
	(assert (instance-of? headers <lws:headers>))
	(assert (string?      content))
	
	(initialize-slots this (list 'method  method
								 'uri     (make <uri> uri)
								 'headers headers
								 'content content)))

  (apply init args))


(define-method (clone (this <lws:request>))
  (with-slots (method uri headers content) this
			  
     (make <lws:request>
	   method
	   (make <uri> uri)
	   headers: (clone headers)
	   content: content)))

