;; -*- hen -*-
(declare (unit cleited-passive-node)	
		 (uses srpc-passive-node
			   db-pod
			   cleited-utils)
		 (export <cleited-passive-node>
				 initialize
				 wrap-method!
				 get-arg
				 true-or-false?
				 true-or-false->number
				 true-or-false->boolean
				 number->true-or-false))

(include "cleited-macros.scm")

(use tinyclos)

(define-class <cleited-passive-node> (<srpc-passive-node>)
  (db-pod))


(define-method (initialize (this <cleited-passive-node>) args)
  (call-next-method)
  
  (define (init #!key db-pod)

	(assert (instance-of? db-pod <db-pod>))

	(initialize-slots this (list 'db-pod db-pod)))
  
  (apply init args))


(define-method (wrap-method! (this <cleited-passive-node>)
							 (name <symbol>)
							 (impl <procedure>))
  (with-slots (db-pod) this
     (let [(wrapper (lambda (arg)

					  (unless (list? arg)
						(error `(not-a-list . ,arg)))

					  (impl arg db-pod)))]
	   
	   (register-method! this name wrapper))))


(define (get-arg arg name #!key check optional)
  (assert (pair? arg))
  (assert (symbol? name))

  (let ((cell (assq name arg)))
	(bind-exit exit

	   (and optional
			(not cell)
			(exit #f))

	   (unless cell
		 (error (format "Argument ~s is not specified" name)))

	 (if check
	     (begin
		   (assert (procedure? check))
		   (unless (check (cdr cell))
			 (error (format "Argument ~s is not properly typed" name)))))

	 (cdr cell))))


(define (true-or-false? obj)
  (and (symbol? obj)
	   (or (eq? 'true  obj)
		   (eq? 'false obj))))


(define (true-or-false->number arg)
  (assert (symbol? arg))
  
  (cond ((eq? arg 'true ) 1)
		((eq? arg 'false) 0)
		(else
		 (error (format "Symbol ~s is neither true nor false" arg)))))


(define (true-or-false->boolean arg)
  (assert (symbol? arg))
  
  (if (= 0 (true-or-false->number arg))
	  #f
	  #t))


(define (number->true-or-false arg)
  (assert (number? arg))
  
  (if (= 0 arg)
	  'false
	  'true))
