(defgroup cleite:face nil
  "Cleite :: Faces"
  :prefix "cleite:"
  :group 'cleite)

(defface cleite:face:unread-feed
  '((((class color) (background light)) (:foreground "DarkOliveGreen" :bold t))
	(((class color) (background dark )) (:foreground "GreenYellow"    :bold t)))
  "Face for a feed which has at least one unread item"
  :group 'cleite:face)

(defface cleite:face:read-feed
  '((((class color) (background light)) (:foreground "Navy"))
	(((class color) (background dark )) (:foreground "SkyBlue")))
  "Face for a feed which has no unread items"
  :group 'cleite:face)

(defface cleite:face:selected-feed
  '((((class color) (background light)) (:foreground "FireBrick"))
	(((class color) (background dark )) (:foreground "cyan"     )))
  "Face for the selected feed"
  :group 'cleite:face)

(defface cleite:face:error
  '((((class color) (background light)) (:foreground "Tomato3" :bold t))
	(((class color) (background dark )) (:foreground "tomato"  :bold t)))
  "Face for error messages"
  :group 'cleite:face)

(defface cleite:face:unread-item
  '((((class color) (background light)) (:foreground "DarkOliveGreen" :bold t))
	(((class color) (background dark )) (:foreground "GreenYellow"    :bold t)))
  "Face for a feed item which has not yet been read"
  :group 'cleite:face)

(defface cleite:face:read-item
  '((((class color) (background light)) (:foreground "Navy"))
	(((class color) (background dark )) (:foreground "SkyBlue")))
  "Face for a feed item which has already been read"
  :group 'cleite:face)

(defface cleite:face:selected-item
  '((((class color) (background light)) (:foreground "FireBrick"))
	(((class color) (background dark )) (:foreground "cyan"     )))
  "Face for the selected feed item"
  :group 'cleite:face)

(defface cleite:face:header-key
  '((((class color) (background light)) (:foreground "Gray30" :bold t))
    (((class color) (background dark )) (:foreground "gray"   :bold t)))
  "Face for header keys of an article"
  :group 'cleite:face)

(defface cleite:face:header-value
  '((((class color) (background light)) (:foreground "Navy"))
    (((class color) (background dark )) (:foreground "yellow")))
  "Face for header values of an article"
  :group 'cleite:face)

(provide 'cleite-face)